stages:
  - test
  - build
  - deploy

unit-test-job:
  stage: test
  image: node:latest
  before_script:
    - wget -q -O - https://dl-ssl.google.com/linux/linux_signing_key.pub | apt-key add -
    - echo "deb http://dl.google.com/linux/chrome/deb/ stable main" > /etc/apt/sources.list.d/google.list
    - apt-get update
    - apt-get install -y google-chrome-stable xvfb
    - npm i -g @angular/cli
  script:
    - npm install
    - ng test --no-watch --browsers=ChromeHeadlessNoSandbox
  except:
    - main
    - dev

lint-test-job:
  stage: test
  image: node:latest
  before_script:
    - npm install -g @angular/cli
    - npm install
  script:
    - ng lint
  except:
    - main
    - dev

build-job:
  stage: build
  image: docker:20.10.16
  services:
    - docker:20.10.16-dind
  variables:
    DOCKER_TLS_CERTDIR: "/certs"
  before_script:
    - docker login -u loydane -p yanis8315!
  script: 
    - docker build -t loydane/lavireeterroirfront:lavireeterroirfront .
    - docker push loydane/lavireeterroirfront:lavireeterroirfront
  only:
    - dev

deploy-job:
  stage: deploy
  image: ruby:3.1
  before_script:
    - chmod 600 $SSH_KEY
  script:
    - ssh -o StrictHostKeyChecking=no -i $SSH_KEY root@161.97.106.80 "
        docker login -u loydane -p yanis8315! &&
        docker stop lavireeterroirfront || true &&
        docker rm lavireeterroirfront || true &&
        docker pull loydane/lavireeterroirfront:lavireeterroirfront &&
        docker run -d --name lavireeterroirfront -p 4200:80 loydane/lavireeterroirfront:lavireeterroirfront"
  only:
    - main